{
    "$graph": [
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        "$(inputs.bwa)",
                        "$(inputs.ref_fasta)"
                    ]
                }
            ],
            "baseCommand": [
                "./bwa",
                "index"
            ],
            "stdout": "bwa-index.out",
            "stderr": "bwa-index.err",
            "inputs": [
                {
                    "type": "File",
                    "id": "#bwa-index.cwl/bwa"
                },
                {
                    "inputBinding": {
                        "position": 2
                    },
                    "type": "File",
                    "id": "#bwa-index.cwl/ref_fasta"
                }
            ],
            "id": "#bwa-index.cwl",
            "outputs": [
                {
                    "outputBinding": {
                        "glob": "ref.fasta.*"
                    },
                    "type": {
                        "items": "File",
                        "type": "array"
                    },
                    "id": "#bwa-index.cwl/ref_fasta_out"
                },
                {
                    "type": "File",
                    "id": "#bwa-index.cwl/stde",
                    "outputBinding": {
                        "glob": "bwa-index.err"
                    }
                },
                {
                    "type": "File",
                    "id": "#bwa-index.cwl/stdo",
                    "outputBinding": {
                        "glob": "bwa-index.out"
                    }
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        "$(inputs.ref_fasta_files)",
                        "$(inputs.bwa)",
                        "$(inputs.ref_fasta)",
                        "$(inputs.query_fastq)"
                    ]
                }
            ],
            "baseCommand": [
                "./bwa",
                "mem",
                "ref.fasta"
            ],
            "stdout": "$(inputs.out_sam)",
            "stderr": "$(inputs.out_err)",
            "inputs": [
                {
                    "type": "File",
                    "id": "#bwa-mem.cwl/bwa"
                },
                {
                    "type": "string",
                    "id": "#bwa-mem.cwl/out_err"
                },
                {
                    "type": "string",
                    "id": "#bwa-mem.cwl/out_sam"
                },
                {
                    "inputBinding": {
                        "position": 3
                    },
                    "type": "File",
                    "id": "#bwa-mem.cwl/query_fastq"
                },
                {
                    "type": "File",
                    "id": "#bwa-mem.cwl/ref_fasta"
                },
                {
                    "type": {
                        "items": "File",
                        "type": "array"
                    },
                    "id": "#bwa-mem.cwl/ref_fasta_files"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#bwa-mem.cwl/stde",
                    "outputBinding": {
                        "glob": "$(inputs.out_err)"
                    }
                },
                {
                    "type": "File",
                    "id": "#bwa-mem.cwl/stdo",
                    "outputBinding": {
                        "glob": "$(inputs.out_sam)"
                    }
                }
            ],
            "id": "#bwa-mem.cwl"
        },
        {
            "class": "Workflow",
            "inputs": [
                {
                    "type": "File",
                    "id": "#main/Correction_py"
                },
                {
                    "type": "File",
                    "id": "#main/Create_Corrected_All_Reads"
                },
                {
                    "type": "File",
                    "id": "#main/Create_SubsetPileup"
                },
                {
                    "type": "File",
                    "id": "#main/Split_Pileup"
                },
                {
                    "type": "File",
                    "id": "#main/bwa"
                },
                {
                    "type": "File",
                    "id": "#main/corr_out"
                },
                {
                    "type": "File",
                    "id": "#main/fasta_reduce_file"
                },
                {
                    "type": "File",
                    "id": "#main/fastq_reduce"
                },
                {
                    "type": "File",
                    "id": "#main/out_bam_file"
                },
                {
                    "type": "string",
                    "id": "#main/out_err_0"
                },
                {
                    "type": "string",
                    "id": "#main/out_err_1"
                },
                {
                    "type": "string",
                    "id": "#main/out_err_2"
                },
                {
                    "type": "string",
                    "id": "#main/out_err_3"
                },
                {
                    "type": "string",
                    "id": "#main/out_err_4"
                },
                {
                    "type": "string",
                    "id": "#main/out_sam_0"
                },
                {
                    "type": "string",
                    "id": "#main/out_sam_1"
                },
                {
                    "type": "string",
                    "id": "#main/out_sam_2"
                },
                {
                    "type": "string",
                    "id": "#main/out_sam_3"
                },
                {
                    "type": "string",
                    "id": "#main/out_sam_4"
                },
                {
                    "type": "File",
                    "id": "#main/out_sam_file"
                },
                {
                    "type": "File",
                    "id": "#main/query_fastq"
                },
                {
                    "type": "File",
                    "id": "#main/query_fastq_0"
                },
                {
                    "type": "File",
                    "id": "#main/query_fastq_1"
                },
                {
                    "type": "File",
                    "id": "#main/query_fastq_2"
                },
                {
                    "type": "File",
                    "id": "#main/query_fastq_3"
                },
                {
                    "type": "File",
                    "id": "#main/query_fastq_4"
                },
                {
                    "type": "File",
                    "id": "#main/ref_fasta"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/ref_fasta_out"
                },
                {
                    "type": "File",
                    "id": "#main/sam_cat_file"
                },
                {
                    "type": "File",
                    "id": "#main/samtools"
                }
            ],
            "outputs": [
                {
                    "outputSource": "#main/sam_cat_err/stdo",
                    "type": "File",
                    "id": "#main/cat_all_stderr"
                },
                {
                    "outputSource": "#main/sam_cat/stdo",
                    "type": "File",
                    "id": "#main/cat_all_stdout"
                }
            ],
            "steps": [
                {
                    "run": "#bwa-index.cwl",
                    "in": [
                        {
                            "source": "#main/bwa",
                            "id": "#main/bwa_index/bwa"
                        },
                        {
                            "source": "#main/ref_fasta",
                            "id": "#main/bwa_index/ref_fasta"
                        }
                    ],
                    "out": [
                        "#main/bwa_index/stdo",
                        "#main/bwa_index/stde",
                        "#main/bwa_index/ref_fasta_out"
                    ],
                    "id": "#main/bwa_index"
                },
                {
                    "run": "#bwa-mem.cwl",
                    "in": [
                        {
                            "source": "#main/bwa",
                            "id": "#main/bwa_mem_0/bwa"
                        },
                        {
                            "source": "#main/out_err_0",
                            "id": "#main/bwa_mem_0/out_err"
                        },
                        {
                            "source": "#main/out_sam_0",
                            "id": "#main/bwa_mem_0/out_sam"
                        },
                        {
                            "source": "#main/query_fastq_0",
                            "id": "#main/bwa_mem_0/query_fastq"
                        },
                        {
                            "source": "#main/ref_fasta",
                            "id": "#main/bwa_mem_0/ref_fasta"
                        },
                        {
                            "source": "#main/ref_fasta_out",
                            "id": "#main/bwa_mem_0/ref_fasta_files"
                        }
                    ],
                    "out": [
                        "#main/bwa_mem_0/stdo",
                        "#main/bwa_mem_0/stde"
                    ],
                    "id": "#main/bwa_mem_0"
                },
                {
                    "run": "#bwa-mem.cwl",
                    "in": [
                        {
                            "source": "#main/bwa",
                            "id": "#main/bwa_mem_1/bwa"
                        },
                        {
                            "source": "#main/out_err_1",
                            "id": "#main/bwa_mem_1/out_err"
                        },
                        {
                            "source": "#main/out_sam_1",
                            "id": "#main/bwa_mem_1/out_sam"
                        },
                        {
                            "source": "#main/query_fastq_1",
                            "id": "#main/bwa_mem_1/query_fastq"
                        },
                        {
                            "source": "#main/ref_fasta",
                            "id": "#main/bwa_mem_1/ref_fasta"
                        },
                        {
                            "source": "#main/ref_fasta_out",
                            "id": "#main/bwa_mem_1/ref_fasta_files"
                        }
                    ],
                    "out": [
                        "#main/bwa_mem_1/stdo",
                        "#main/bwa_mem_1/stde"
                    ],
                    "id": "#main/bwa_mem_1"
                },
                {
                    "run": "#bwa-mem.cwl",
                    "in": [
                        {
                            "source": "#main/bwa",
                            "id": "#main/bwa_mem_2/bwa"
                        },
                        {
                            "source": "#main/out_err_2",
                            "id": "#main/bwa_mem_2/out_err"
                        },
                        {
                            "source": "#main/out_sam_2",
                            "id": "#main/bwa_mem_2/out_sam"
                        },
                        {
                            "source": "#main/query_fastq_2",
                            "id": "#main/bwa_mem_2/query_fastq"
                        },
                        {
                            "source": "#main/ref_fasta",
                            "id": "#main/bwa_mem_2/ref_fasta"
                        },
                        {
                            "source": "#main/ref_fasta_out",
                            "id": "#main/bwa_mem_2/ref_fasta_files"
                        }
                    ],
                    "out": [
                        "#main/bwa_mem_2/stdo",
                        "#main/bwa_mem_2/stde"
                    ],
                    "id": "#main/bwa_mem_2"
                },
                {
                    "run": "#bwa-mem.cwl",
                    "in": [
                        {
                            "source": "#main/bwa",
                            "id": "#main/bwa_mem_3/bwa"
                        },
                        {
                            "source": "#main/out_err_3",
                            "id": "#main/bwa_mem_3/out_err"
                        },
                        {
                            "source": "#main/out_sam_3",
                            "id": "#main/bwa_mem_3/out_sam"
                        },
                        {
                            "source": "#main/query_fastq_3",
                            "id": "#main/bwa_mem_3/query_fastq"
                        },
                        {
                            "source": "#main/ref_fasta",
                            "id": "#main/bwa_mem_3/ref_fasta"
                        },
                        {
                            "source": "#main/ref_fasta_out",
                            "id": "#main/bwa_mem_3/ref_fasta_files"
                        }
                    ],
                    "out": [
                        "#main/bwa_mem_3/stdo",
                        "#main/bwa_mem_3/stde"
                    ],
                    "id": "#main/bwa_mem_3"
                },
                {
                    "run": "#bwa-mem.cwl",
                    "in": [
                        {
                            "source": "#main/bwa",
                            "id": "#main/bwa_mem_4/bwa"
                        },
                        {
                            "source": "#main/out_err_4",
                            "id": "#main/bwa_mem_4/out_err"
                        },
                        {
                            "source": "#main/out_sam_4",
                            "id": "#main/bwa_mem_4/out_sam"
                        },
                        {
                            "source": "#main/query_fastq_4",
                            "id": "#main/bwa_mem_4/query_fastq"
                        },
                        {
                            "source": "#main/ref_fasta",
                            "id": "#main/bwa_mem_4/ref_fasta"
                        },
                        {
                            "source": "#main/ref_fasta_out",
                            "id": "#main/bwa_mem_4/ref_fasta_files"
                        }
                    ],
                    "out": [
                        "#main/bwa_mem_4/stdo",
                        "#main/bwa_mem_4/stde"
                    ],
                    "id": "#main/bwa_mem_4"
                },
                {
                    "run": "#perl.cwl",
                    "in": [
                        {
                            "source": "#main/fastq_reduce",
                            "id": "#main/perl/fastq_reduce"
                        },
                        {
                            "source": "#main/query_fastq",
                            "id": "#main/perl/query_fastq"
                        }
                    ],
                    "out": [
                        "#main/perl/stdout",
                        "#main/perl/stde",
                        "#main/perl/query_fastq_0",
                        "#main/perl/query_fastq_1",
                        "#main/perl/query_fastq_2",
                        "#main/perl/query_fastq_3",
                        "#main/perl/query_fastq_4"
                    ],
                    "id": "#main/perl"
                },
                {
                    "run": "#sam-cat.cwl",
                    "in": [
                        {
                            "source": "#main/bwa_mem_0/stdo",
                            "id": "#main/sam_cat/Out_0_sam"
                        },
                        {
                            "source": "#main/bwa_mem_1/stdo",
                            "id": "#main/sam_cat/Out_1_sam"
                        },
                        {
                            "source": "#main/bwa_mem_2/stdo",
                            "id": "#main/sam_cat/Out_2_sam"
                        },
                        {
                            "source": "#main/bwa_mem_3/stdo",
                            "id": "#main/sam_cat/Out_3_sam"
                        },
                        {
                            "source": "#main/bwa_mem_4/stdo",
                            "id": "#main/sam_cat/Out_4_sam"
                        },
                        {
                            "source": "#main/sam_cat_file",
                            "id": "#main/sam_cat/sam_cat_file"
                        }
                    ],
                    "out": [
                        "#main/sam_cat/stdo"
                    ],
                    "id": "#main/sam_cat"
                },
                {
                    "run": "#sam-cat-err.cwl",
                    "in": [
                        {
                            "source": "#main/bwa_mem_0/stde",
                            "id": "#main/sam_cat_err/mem_0_err"
                        },
                        {
                            "source": "#main/bwa_mem_1/stde",
                            "id": "#main/sam_cat_err/mem_1_err"
                        },
                        {
                            "source": "#main/bwa_mem_2/stde",
                            "id": "#main/sam_cat_err/mem_2_err"
                        },
                        {
                            "source": "#main/bwa_mem_3/stde",
                            "id": "#main/sam_cat_err/mem_3_err"
                        },
                        {
                            "source": "#main/bwa_mem_4/stde",
                            "id": "#main/sam_cat_err/mem_4_err"
                        }
                    ],
                    "out": [
                        "#main/sam_cat_err/stdo"
                    ],
                    "id": "#main/sam_cat_err"
                }
            ],
            "id": "#main"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        "$(inputs.fastq_reduce)",
                        "$(inputs.query_fastq)"
                    ]
                }
            ],
            "baseCommand": [
                "perl",
                "fastq_reduce",
                "query.fastq",
                "5"
            ],
            "stdout": "perl.out",
            "stderr": "perl.err",
            "inputs": [
                {
                    "type": "File",
                    "id": "#perl.cwl/fastq_reduce"
                },
                {
                    "type": "File",
                    "id": "#perl.cwl/query_fastq"
                }
            ],
            "outputs": [
                {
                    "outputBinding": {
                        "glob": "query.fastq.0"
                    },
                    "type": "File",
                    "id": "#perl.cwl/query_fastq_0"
                },
                {
                    "outputBinding": {
                        "glob": "query.fastq.1"
                    },
                    "type": "File",
                    "id": "#perl.cwl/query_fastq_1"
                },
                {
                    "outputBinding": {
                        "glob": "query.fastq.2"
                    },
                    "type": "File",
                    "id": "#perl.cwl/query_fastq_2"
                },
                {
                    "outputBinding": {
                        "glob": "query.fastq.3"
                    },
                    "type": "File",
                    "id": "#perl.cwl/query_fastq_3"
                },
                {
                    "outputBinding": {
                        "glob": "query.fastq.4"
                    },
                    "type": "File",
                    "id": "#perl.cwl/query_fastq_4"
                },
                {
                    "type": "File",
                    "id": "#perl.cwl/stde",
                    "outputBinding": {
                        "glob": "perl.err"
                    }
                },
                {
                    "type": "File",
                    "id": "#perl.cwl/stdout",
                    "outputBinding": {
                        "glob": "perl.out"
                    }
                }
            ],
            "id": "#perl.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        "$(inputs.mem_0_err)",
                        "$(inputs.mem_1_err)",
                        "$(inputs.mem_2_err)",
                        "$(inputs.mem_3_err)",
                        "$(inputs.mem_4_err)"
                    ]
                }
            ],
            "baseCommand": [
                "cat"
            ],
            "stdout": "mem.err",
            "inputs": [
                {
                    "inputBinding": {
                        "position": 1
                    },
                    "type": "File",
                    "id": "#sam-cat-err.cwl/mem_0_err"
                },
                {
                    "inputBinding": {
                        "position": 2
                    },
                    "type": "File",
                    "id": "#sam-cat-err.cwl/mem_1_err"
                },
                {
                    "inputBinding": {
                        "position": 3
                    },
                    "type": "File",
                    "id": "#sam-cat-err.cwl/mem_2_err"
                },
                {
                    "inputBinding": {
                        "position": 4
                    },
                    "type": "File",
                    "id": "#sam-cat-err.cwl/mem_3_err"
                },
                {
                    "inputBinding": {
                        "position": 5
                    },
                    "type": "File",
                    "id": "#sam-cat-err.cwl/mem_4_err"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#sam-cat-err.cwl/stdo",
                    "outputBinding": {
                        "glob": "mem.err"
                    }
                }
            ],
            "id": "#sam-cat-err.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        "$(inputs.sam_cat_file)",
                        "$(inputs.Out_0_sam)",
                        "$(inputs.Out_1_sam)",
                        "$(inputs.Out_2_sam)",
                        "$(inputs.Out_3_sam)",
                        "$(inputs.Out_4_sam)"
                    ]
                }
            ],
            "baseCommand": [
                "bash",
                "sam_cat.sh",
                "Out.*.sam"
            ],
            "stdout": "Out.sam",
            "inputs": [
                {
                    "type": "File",
                    "id": "#sam-cat.cwl/Out_0_sam"
                },
                {
                    "type": "File",
                    "id": "#sam-cat.cwl/Out_1_sam"
                },
                {
                    "type": "File",
                    "id": "#sam-cat.cwl/Out_2_sam"
                },
                {
                    "type": "File",
                    "id": "#sam-cat.cwl/Out_3_sam"
                },
                {
                    "type": "File",
                    "id": "#sam-cat.cwl/Out_4_sam"
                },
                {
                    "type": "File",
                    "id": "#sam-cat.cwl/sam_cat_file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#sam-cat.cwl/stdo",
                    "outputBinding": {
                        "glob": "Out.sam"
                    }
                }
            ],
            "id": "#sam-cat.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
